"use strict";
var __esDecorate = (this && this.__esDecorate) || function (ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
    function accept(f) { if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected"); return f; }
    var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
    var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
    var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
    var _, done = false;
    for (var i = decorators.length - 1; i >= 0; i--) {
        var context = {};
        for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
        for (var p in contextIn.access) context.access[p] = contextIn.access[p];
        context.addInitializer = function (f) { if (done) throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
        var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
        if (kind === "accessor") {
            if (result === void 0) continue;
            if (result === null || typeof result !== "object") throw new TypeError("Object expected");
            if (_ = accept(result.get)) descriptor.get = _;
            if (_ = accept(result.set)) descriptor.set = _;
            if (_ = accept(result.init)) initializers.unshift(_);
        }
        else if (_ = accept(result)) {
            if (kind === "field") initializers.unshift(_);
            else descriptor[key] = _;
        }
    }
    if (target) Object.defineProperty(target, contextIn.name, descriptor);
    done = true;
};
var __runInitializers = (this && this.__runInitializers) || function (thisArg, initializers, value) {
    var useValue = arguments.length > 2;
    for (var i = 0; i < initializers.length; i++) {
        value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
    }
    return useValue ? value : void 0;
};
var __setFunctionName = (this && this.__setFunctionName) || function (f, name, prefix) {
    if (typeof name === "symbol") name = name.description ? "[".concat(name.description, "]") : "";
    return Object.defineProperty(f, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GenericVisitor = exports.GenericSeed = void 0;
const utils_1 = require("../utils");
let GenericSeed = (() => {
    let _classDecorators = [(0, utils_1.staticImplements)()];
    let _classDescriptor;
    let _classExtraInitializers = [];
    let _classThis;
    var GenericSeed = _classThis = class {
        static deserialize(deserializer) {
            return deserializer.deserializeAny(new GenericVisitor());
        }
        deserialize(deserializer) {
            return GenericSeed.deserialize(deserializer);
        }
    };
    __setFunctionName(_classThis, "GenericSeed");
    (() => {
        const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(null) : void 0;
        __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
        GenericSeed = _classThis = _classDescriptor.value;
        if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
        __runInitializers(_classThis, _classExtraInitializers);
    })();
    return GenericSeed = _classThis;
})();
exports.GenericSeed = GenericSeed;
class GenericVisitor {
    visitString(value) {
        return value;
    }
    visitNumber(value) {
        return value;
    }
    visitBigInt(value) {
        return value;
    }
    visitBoolean(value) {
        return value;
    }
    visitSymbol(value) {
        return value;
    }
    visitNull() {
        return null;
    }
    visitObject(access) {
        const result = {};
        let entry;
        while ((entry = access.nextEntry())) {
            result[entry[0]] = entry[1];
        }
        return result;
    }
    visitClass(name, value) {
        console.log(name, '!!!!!!');
        return this.visitObject(value);
    }
    visitIterable(access) {
        const result = new Array(access.sizeHint());
        let element;
        while ((element = access.nextElement())) {
            result.push(element);
        }
        return result;
    }
}
exports.GenericVisitor = GenericVisitor;
